weka.filters.unsupervised.attribute

## Class ReplaceWithMissingValue

- java.lang.Object
- - weka.filters.Filter
  - - weka.filters.SimpleFilter
    - - weka.filters.SimpleBatchFilter
      - - weka.filters.unsupervised.attribute.ReplaceWithMissingValue

- All Implemented Interfaces:
    java.io.Serializable, CapabilitiesHandler, CapabilitiesIgnorer, CommandlineRunnable, OptionHandler, Randomizable, RevisionHandler, WeightedAttributesHandler, WeightedInstancesHandler, UnsupervisedFilter

      public class ReplaceWithMissingValue
      extends SimpleBatchFilter
      implements UnsupervisedFilter, Randomizable, WeightedAttributesHandler, WeightedInstancesHandler

  A filter that can be used to introduce missing values in a dataset. The specified probability is used to flip a biased coin to decide whether to replace a particular attribute value in an instance with a missing value (i.e., a probability of 0.9 means 90% of values will be replaced with missing values). This filter only modifies the first batch of data that is processed. The class attribute is skipped by default.
  Valid options are:

       -R <col1,col2-col4,...>
        Specifies list of columns to modify. First and last are valid indexes.
        (default: first-last)

       -V
        Invert matching sense of column indexes.

       -S <num>
        Specify the random number seed (default 1)

       -P <double>
        Specify the probability  (default 0.1)

       -unset-class-temporarily
        Unsets the class index temporarily before the filter is
        applied to the data.
        (default: no)

  Version:
    $Revision: 10215 $
  Author:
    Eibe Frank (eibe@cs.waikato.ac.nz)
  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `ReplaceWithMissingValue()`

  - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.String` | `attributeIndicesTipText()` Returns the tip text for this property
    `java.lang.String` | `getAttributeIndices()` Gets the current range selection
    `Capabilities` | `getCapabilities()` Returns the Capabilities of this filter.
    `boolean` | `getIgnoreClass()` Gets the IgnoreClass value.
    `boolean` | `getInvertSelection()` Gets whether the supplied columns are to be worked on or the others.
    `java.lang.String[]` | `getOptions()` Gets the current settings of the filter.
    `double` | `getProbability()` Get the probability.
    `java.lang.String` | `getRevision()` Returns the revision string.
    `int` | `getSeed()` Get the random number generator seed value.
    `java.lang.String` | `globalInfo()` Returns a string describing this filter.
    `java.lang.String` | `ignoreClassTipText()` Returns the tip text for this property
    `java.lang.String` | `invertSelectionTipText()` Returns the tip text for this property
    `java.util.Enumeration<Option>` | `listOptions()` Gets an enumeration describing the available options.
    `static void` | `main(java.lang.String[] argv)` Main method for testing this class.
    `java.lang.String` | `probabilityTipText()` Returns the tip text for this property
    `java.lang.String` | `seedTipText()` Returns the tip text for this property
    `void` | `setAttributeIndices(java.lang.String value)` Sets which attributes are to be "nominalized" (only numeric attributes among the selection will be transformed).
    `void` | `setAttributeIndicesArray(int[] value)` Sets which attributes are to be transoformed to nominal.
    `void` | `setIgnoreClass(boolean newIgnoreClass)` Set the IgnoreClass value.
    `void` | `setInvertSelection(boolean value)` Sets whether selected columns should be worked on or all the others apart from these.
    `void` | `setOptions(java.lang.String[] options)` Parses a given list of options.
    `void` | `setProbability(double newProbability)` Set the probability to use.
    `void` | `setSeed(int newSeed)` Set the random number generator seed value.

    - ### Methods inherited from class weka.filters.SimpleBatchFilter

      `allowAccessToFullInputFormat, batchFinished, input, input`

    - ### Methods inherited from class weka.filters.SimpleFilter

      `setInputFormat`

    - ### Methods inherited from class weka.filters.Filter

      `batchFilterFile, debugTipText, doNotCheckCapabilitiesTipText, filterFile, getCapabilities, getCopyOfInputFormat, getDebug, getDoNotCheckCapabilities, getOutputFormat, isFirstBatchDone, isNewBatch, isOutputFormatDefined, makeCopies, makeCopy, mayRemoveInstanceAfterFirstBatchDone, numPendingOutput, output, outputPeek, postExecution, preExecution, run, runFilter, setDebug, setDoNotCheckCapabilities, toString, useFilter, wekaStaticWrapper`

    - ### Methods inherited from class java.lang.Object

      `equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### ReplaceWithMissingValue

          public ReplaceWithMissingValue()

  - ### Method Detail

    - #### listOptions

          public java.util.Enumeration<Option> listOptions()

      Gets an enumeration describing the available options.
      Specified by:
        `listOptions` in interface `OptionHandler`
      Overrides:
        `listOptions` in class `Filter`
      Returns:
        an enumeration of all the available options.

    - #### setOptions

          public void setOptions(java.lang.String[] options)
                          throws java.lang.Exception

      Parses a given list of options.

      Valid options are:

           -R <col1,col2-col4,...>
            Specifies list of columns to modify. First and last are valid indexes.
            (default: first-last)

           -V
            Invert matching sense of column indexes.

           -S <num>
            Specify the random number seed (default 1)

           -P <double>
            Specify the probability  (default 0.1)

           -unset-class-temporarily
            Unsets the class index temporarily before the filter is
            applied to the data.
            (default: no)

      Specified by:
        `setOptions` in interface `OptionHandler`
      Overrides:
        `setOptions` in class `Filter`
      Parameters:
        `options` - the list of options as an array of strings
      Throws:
        `java.lang.Exception` - if an option is not supported

    - #### getOptions

          public java.lang.String[] getOptions()

      Gets the current settings of the filter.
      Specified by:
        `getOptions` in interface `OptionHandler`
      Overrides:
        `getOptions` in class `Filter`
      Returns:
        an array of strings suitable for passing to setOptions

    - #### ignoreClassTipText

          public java.lang.String ignoreClassTipText()

      Returns the tip text for this property
      Returns:
        tip text for this property suitable for displaying in the explorer/experimenter gui

    - #### setIgnoreClass

          public void setIgnoreClass(boolean newIgnoreClass)

      Set the IgnoreClass value. Set this to true if the class index is to be unset before the filter is applied.
      Parameters:
        `newIgnoreClass` - The new IgnoreClass value.

    - #### getIgnoreClass

          public boolean getIgnoreClass()

      Gets the IgnoreClass value. If this to true then the class index is to unset before the filter is applied.
      Returns:
        the current IgnoreClass value.

    - #### probabilityTipText

          public java.lang.String probabilityTipText()

      Returns the tip text for this property
      Returns:
        tip text for this property suitable for displaying in the explorer/experimenter gui

    - #### getProbability

          public double getProbability()

      Get the probability.
      Returns:
        the probability.

    - #### setProbability

          public void setProbability(double newProbability)

      Set the probability to use.
      Parameters:
        `newProbability` - the probability to use.

    - #### seedTipText

          public java.lang.String seedTipText()

      Returns the tip text for this property
      Returns:
        tip text for this property suitable for displaying in the explorer/experimenter gui

    - #### getSeed

          public int getSeed()

      Get the random number generator seed value.
      Specified by:
        `getSeed` in interface `Randomizable`
      Returns:
        random number generator seed value.

    - #### setSeed

          public void setSeed(int newSeed)

      Set the random number generator seed value.
      Specified by:
        `setSeed` in interface `Randomizable`
      Parameters:
        `newSeed` - value to use as the random number generator seed.

    - #### invertSelectionTipText

          public java.lang.String invertSelectionTipText()

      Returns the tip text for this property
      Returns:
        tip text for this property suitable for displaying in the explorer/experimenter gui

    - #### getInvertSelection

          public boolean getInvertSelection()

      Gets whether the supplied columns are to be worked on or the others.
      Returns:
        true if the supplied columns will be worked on

    - #### setInvertSelection

          public void setInvertSelection(boolean value)

      Sets whether selected columns should be worked on or all the others apart from these. If true all the other columns are considered for "nominalization".
      Parameters:
        `value` - the new invert setting

    - #### attributeIndicesTipText

          public java.lang.String attributeIndicesTipText()

      Returns the tip text for this property
      Returns:
        tip text for this property suitable for displaying in the explorer/experimenter gui

    - #### getAttributeIndices

          public java.lang.String getAttributeIndices()

      Gets the current range selection
      Returns:
        a string containing a comma separated list of ranges

    - #### setAttributeIndices

          public void setAttributeIndices(java.lang.String value)

      Sets which attributes are to be "nominalized" (only numeric attributes among the selection will be transformed).
      Parameters:
        `value` - a string representing the list of attributes. Since the string will typically come from a user, attributes are indexed from 1.
        eg: first-3,5,6-last
      Throws:
        `java.lang.IllegalArgumentException` - if an invalid range list is supplied

    - #### setAttributeIndicesArray

          public void setAttributeIndicesArray(int[] value)

      Sets which attributes are to be transoformed to nominal. (only numeric attributes among the selection will be transformed).
      Parameters:
        `value` - an array containing indexes of attributes to nominalize. Since the array will typically come from a program, attributes are indexed from 0.
      Throws:
        `java.lang.IllegalArgumentException` - if an invalid set of ranges is supplied

    - #### getCapabilities

          public Capabilities getCapabilities()

      Returns the Capabilities of this filter.
      Specified by:
        `getCapabilities` in interface `CapabilitiesHandler`
      Overrides:
        `getCapabilities` in class `Filter`
      Returns:
        the capabilities of this object
      See Also:
        `Capabilities`

    - #### globalInfo

          public java.lang.String globalInfo()

      Returns a string describing this filter.
      Specified by:
        `globalInfo` in class `SimpleFilter`
      Returns:
        a description of the filter suitable for displaying in the explorer/experimenter gui

    - #### getRevision

          public java.lang.String getRevision()

      Returns the revision string.
      Specified by:
        `getRevision` in interface `RevisionHandler`
      Overrides:
        `getRevision` in class `Filter`
      Returns:
        the revision

    - #### main

          public static void main(java.lang.String[] argv)

      Main method for testing this class.
      Parameters:
        `argv` - should contain arguments to the filter: use -h for help